#ifndef _JDISP_BROWSER_JSH
#define _JDISP_BROWSER_JSH

#define BROWSER_IS_IE() (HAS_SUBSTRING(navigator.userAgent, "MSIE"))
#define BROWSER_IS_FIREFOX() (HAS_SUBSTRING(navigator.userAgent, "Firefox"))
#define BROWSER_IS_OPERA() (IS_DEFINED(window.opera))
#define BROWSER_IS_CHROME() (HAS_SUBSTRING(navigator.userAgent, "Chrome"))
#define BROWSER_IS_SAFARI() (HAS_SUBSTRING(navigator.userAgent, "Apple"))
#define BROWSER_IS_KONQUEROR() (HAS_SUBSTRING(navigator.vendor, "KDE"))
#define BROWSER_IS_OMNIWEB() (HAS_SUBSTRING(navigator.userAgent, "OmniWeb"))
#define BROWSER_IS_ICAB() (HAS_SUBSTRING(navigator.vendor, "iCab"))
#define BROWSER_IS_CAMINO() (HAS_SUBSTRING(navigator.vendor, "Camino"))
#define BROWSER_IS_NETSCAPE() (HAS_SUBSTRING(navigator.userAgent, "Netscape") \
  || HAS_SUBSTRING(navigator.userAgent, "Gecko") \
  || HAS_SUBSTRING(navigator.userAgent, "Mozilla") \
  )
#define TEST_BROWSER(n) (("BROWSER_IS_" + #n + "=") + (BROWSER_IS_##n()))
#define TEST_BROWSER_DETECTION(log) (function () { \
  log.append(TEST_BROWSER(IE)); \
  log.append(TEST_BROWSER(FIREFOX)); \
  log.append(TEST_BROWSER(OPERA)); \
  log.append(TEST_BROWSER(CHROME)); \
  log.append(TEST_BROWSER(SAFARI)); \
  log.append(TEST_BROWSER(KONQUEROR)); \
  log.append(TEST_BROWSER(OMNIWEB)); \
  log.append(TEST_BROWSER(ICAB)); \
  log.append(TEST_BROWSER(CAMINO)); \
  log.append(TEST_BROWSER(NETSCAPE)); \
})()

OOP_CLASS(Browser) = function()
{
};

OOP_METHOD(Browser, test) = function(log)
{
  TEST_BROWSER_DETECTION(log);
};

#endif /* _JDISP_BROWSER_JSH */
